#include <stdlib.h>
#include <string.h>
#include "device.h"

struct device *device_magellan(void);

static struct device *devlist;
static char *port;

void register_all(void)
{
	struct device *dev;

	if((dev = device_magellan()) && dev->init() != -1) {
		dev->next = devlist;
		devlist = dev;
	}
}

struct device *dev_init(const char *name)
{
	struct device *dev = devlist;

	while(dev) {
		if(name) {
			if(strcmp(dev->name, name) == 0) {
				return dev->detect() ? dev : 0;
			}
		} else {
			if(dev->detect()) {
				return dev;
			}
		}
		dev = dev->next;
	}
	return 0;
}

void dev_destroy(void)
{
	while(devlist) {
		struct device *dev = devlist;
		devlist = devlist->next;
		dev->destroy();
	}
	devlist = 0;
}

void set_port(const char *s)
{
	free(port);
	port = strdup(s);
}

const char *get_port(void)
{
	return port;
}
