#ifndef DEVICE_H_
#define DEVICE_H_

enum {
	DEV_EV_NONE,
	DEV_EV_MOTION,
	DEV_EV_BUTTON
};

struct device_event_motion {
	int type;
	int motion[6];
};

struct device_event_button {
	int type;
	int id;
	int pressed;
	unsigned int state;
};

typedef union device_event {
	int type;
	struct device_event_motion motion;
	struct device_event_button button;
} device_event;

struct device {
	char *name;
	struct device *next;

	int (*init)(void);
	void (*destroy)(void);

	int (*detect)(void);

	int (*start)(void);
	void (*stop)(void);

	int (*pending)(void);
	int (*getevent)(device_event*);
};

void register_all(void);

/* name 0 to auto-detect */
struct device *dev_init(const char *name);
void dev_destroy(void);

void set_port(const char *s);
const char *get_port(void);

#endif	/* DEVICE_H_ */
